datacache <- new.env(hash=TRUE, parent=emptyenv())

drosgenome1dmrefseq <- function() showQCData("drosgenome1dmrefseq", datacache)
drosgenome1dmrefseq_dbconn <- function() dbconn(datacache)
drosgenome1dmrefseq_dbfile <- function() dbfile(datacache)
drosgenome1dmrefseq_dbschema <- function(file="", show.indices=FALSE) dbschema(datacache, file=file, show.indices=show.indices)
drosgenome1dmrefseq_dbInfo <- function() dbInfo(datacache)

drosgenome1dmrefseqORGANISM <- "Drosophila melanogaster"

.onLoad <- function(libname, pkgname)
{
    ## Connect to the SQLite DB
    dbfile <- system.file("extdata", "drosgenome1dmrefseq.sqlite", package=pkgname, lib.loc=libname)
    assign("dbfile", dbfile, envir=datacache)
    dbconn <- dbFileConnect(dbfile)
    assign("dbconn", dbconn, envir=datacache)

    ## Create the OrgDb object
    sPkgname <- sub(".db$","",pkgname)
    txdb <- loadDb(system.file("extdata", paste(sPkgname,
      ".sqlite",sep=""), package=pkgname, lib.loc=libname),
                   packageName=pkgname)    
    dbNewname <- AnnotationDbi:::dbObjectName(pkgname,"ChipDb")
    ns <- asNamespace(pkgname)
    assign(dbNewname, txdb, envir=ns)
    namespaceExport(ns, dbNewname)
        
    ## Create the AnnObj instances
    ann_objs <- createAnnObjs.SchemaChoice("FLYCHIP_DB", "drosgenome1dmrefseq", "chip drosgenome1dmrefseq", dbconn, datacache)
    mergeToNamespaceAndExport(ann_objs, pkgname)
    packageStartupMessage(AnnotationDbi:::annoStartupMessages("drosgenome1dmrefseq.db"))
}

.onUnload <- function(libpath)
{
    dbFileDisconnect(drosgenome1dmrefseq_dbconn())
}

